commit c7e066e72fab46e7a31660762cffd5f1e523fbd8
Author: freddy77 <freddy77>
Date:   Sat Jul 3 09:14:36 2010 +0000

    add ODBC wide support (disabled by default and still experimental)

diff --git a/ChangeLog b/ChangeLog
index f1d23be..58ea7f1 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,10 @@
+Sat Jul  3 11:14:29 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* configure.ac include/tdsodbc.h src/odbc/convert_tds2sql.c:
+	* src/odbc/odbc.c src/odbc/odbc_util.c src/odbc/sql2tds.c:
+	* src/odbc/sqlwparams.h:
+	- add ODBC wide support (disabled by default and still
+	  experimental)
+
 Sat Jul  3 10:53:03 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/replacements/iconv.c: fix return codes from replacement iconv
 
@@ -2577,4 +2584,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3055 2010/07/03 08:53:13 freddy77 Exp $
+$Id: ChangeLog,v 1.3056 2010/07/03 09:14:36 freddy77 Exp $
diff --git a/configure.ac b/configure.ac
index 392c4d0..245e377 100644
--- a/configure.ac
+++ b/configure.ac
@@ -1,7 +1,7 @@
 dnl Process this file with autoconf to produce a configure script.
 
 dnl ------------------------------------------------------------
-dnl $Id: configure.ac,v 1.50 2010/07/03 06:57:56 freddy77 Exp $
+dnl $Id: configure.ac,v 1.51 2010/07/03 09:14:36 freddy77 Exp $
 dnl If you're trying to create a new configure test, try
 dnl
 dnl 	http://autogen.sourceforge.net/conftest.html
@@ -15,7 +15,7 @@ dnl ------------------------------------------------------------
 AC_INIT(FreeTDS, 0.83.dev.esyscmd(echo -n $(date +"%Y%m%d")))
 AC_CONFIG_SRCDIR(src/dblib/dblib.c)
 AC_PREREQ(2.53)
-AC_REVISION($Revision: 1.50 $)
+AC_REVISION($Revision: 1.51 $)
 
 AM_INIT_AUTOMAKE([dist-bzip2])
 AC_CONFIG_HEADERS(include/config.h)
@@ -769,6 +769,15 @@ if test "$enable_developing" = "yes" ; then
 	AC_DEFINE_UNQUOTED(ENABLE_DEVELOPING, 1, [Define to enable work in progress code])
 fi
 
+AC_ARG_ENABLE(odbc-wide,
+  AS_HELP_STRING([--enable-odbc-wide], [enable wide string support in odbc [experimental]]))
+if test "$enable_odbc_wide" = "yes" ; then
+	if test "$use_libiconv" != "yes" ; then
+		AC_MSG_ERROR([iconv required for ODBC wide support.])
+	fi
+	AC_DEFINE_UNQUOTED(ENABLE_ODBC_WIDE, 1, [Define to enable ODBC wide string support. Require libiconv!])
+fi
+
 AC_ARG_ENABLE(distcheck_build,
   AS_HELP_STRING([--enable-distcheck-build], [used internally for testing]))
 if test "$enable_distcheck_build" = "yes" ; then
diff --git a/include/tdsodbc.h b/include/tdsodbc.h
index 8dba90e..8d0d972 100644
--- a/include/tdsodbc.h
+++ b/include/tdsodbc.h
@@ -66,7 +66,7 @@ extern "C"
 #endif
 #endif
 
-/* $Id: tdsodbc.h,v 1.122 2010/07/02 13:38:24 freddy77 Exp $ */
+/* $Id: tdsodbc.h,v 1.123 2010/07/03 09:14:36 freddy77 Exp $ */
 
 #if defined(__GNUC__) && __GNUC__ >= 4 && !defined(__MINGW32__)
 #pragma GCC visibility push(hidden)
@@ -250,6 +250,11 @@ struct _hdbc
 	TDSSOCKET *tds_socket;
 	DSTR dsn;
 	DSTR server;		/* aka Instance */
+#ifdef ENABLE_ODBC_WIDE
+	DSTR original_charset;
+	TDSICONV *mb_conv;
+#endif
+
 	/**
 	 * Statement executing. This should be set AFTER sending query
 	 * to avoid race condition and assure to not overwrite it if
@@ -531,13 +536,24 @@ void odbc_check_desc_extra(TDS_DESC * desc);
 /*
  * odbc_util.h
  */
+
 /* helpers for ODBC wide string support */
 #undef _wide
 #undef _WIDE
+#ifdef ENABLE_ODBC_WIDE
+typedef union {
+	char mb[1];
+	SQLWCHAR wide[1];
+} ODBC_CHAR;
+# define _wide ,wide
+# define _wide0 ,0
+# define _WIDE ,int wide
+#else
 # define _wide
 # define _wide0
 # define _WIDE
 # define ODBC_CHAR SQLCHAR
+#endif
 int odbc_set_stmt_query(struct _hstmt *stmt, const ODBC_CHAR *sql, int sql_len _WIDE);
 int odbc_set_stmt_prepared_query(struct _hstmt *stmt, const ODBC_CHAR *sql, int sql_len _WIDE);
 void odbc_set_return_status(struct _hstmt *stmt, unsigned int n_row);
@@ -556,10 +572,17 @@ SQLINTEGER odbc_get_param_len(const struct _drecord *drec_axd, const struct _dre
 DSTR* odbc_dstr_copy(TDS_DBC *dbc, DSTR *s, int size, ODBC_CHAR * str _WIDE);
 
 SQLRETURN odbc_set_string_flag(TDS_DBC *dbc, SQLPOINTER buffer, SQLINTEGER cbBuffer, void FAR * pcbBuffer, const char *s, int len, int flag);
+#ifdef ENABLE_ODBC_WIDE
+static inline SQLRETURN odbc_set_string(TDS_DBC *dbc, SQLPOINTER buffer, SQLSMALLINT cbBuffer, SQLSMALLINT FAR * pcbBuffer, const char *s, int len _WIDE)
+{ return odbc_set_string_flag(dbc, buffer, cbBuffer, (void FAR*) pcbBuffer, s, len, 0|wide); }
+static inline SQLRETURN odbc_set_string_i(TDS_DBC *dbc, SQLPOINTER buffer, SQLINTEGER cbBuffer, SQLINTEGER FAR * pcbBuffer, const char *s, int len _WIDE)
+{ return odbc_set_string_flag(dbc, buffer, cbBuffer, (void FAR*) pcbBuffer, s, len, 0x10|wide); }
+#else
 static inline SQLRETURN odbc_set_string(TDS_DBC *dbc, SQLPOINTER buffer, SQLSMALLINT cbBuffer, SQLSMALLINT FAR * pcbBuffer, const char *s, int len _WIDE)
 { return odbc_set_string_flag(dbc, buffer, cbBuffer, (void FAR*) pcbBuffer, s, len, 0); }
 static inline SQLRETURN odbc_set_string_i(TDS_DBC *dbc, SQLPOINTER buffer, SQLINTEGER cbBuffer, SQLINTEGER FAR * pcbBuffer, const char *s, int len _WIDE)
 { return odbc_set_string_flag(dbc, buffer, cbBuffer, (void FAR*) pcbBuffer, s, len, 0x10); }
+#endif
 
 SQLSMALLINT odbc_get_concise_sql_type(SQLSMALLINT type, SQLSMALLINT interval);
 SQLRETURN odbc_set_concise_sql_type(SQLSMALLINT concise_type, struct _drecord *drec, int check_only);
diff --git a/src/odbc/convert_tds2sql.c b/src/odbc/convert_tds2sql.c
index e523362..57e3af2 100644
--- a/src/odbc/convert_tds2sql.c
+++ b/src/odbc/convert_tds2sql.c
@@ -37,12 +37,13 @@
 #include "tdsodbc.h"
 #include "tdsconvert.h"
 #include "tdsiconv.h"
+#include "tdsstring.h"
 
 #ifdef DMALLOC
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.70 2010/01/07 13:56:55 freddy77 Exp $");
+TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.71 2010/07/03 09:14:36 freddy77 Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -66,6 +67,10 @@ odbc_convert_char(TDS_STMT * stmt, TDSCOLUMN * curcol, TDS_CHAR * src, TDS_UINT
 		conv = tds_iconv_get(tds, ODBC_WIDE_NAME, conv->server_charset.name);
 		if (!conv)
 			conv = tds_iconv_get(tds, ODBC_WIDE_NAME, "ISO-8859-1");
+#ifdef ENABLE_ODBC_WIDE
+	} else {
+		conv = tds_iconv_get(tds, tds_dstr_cstr(&stmt->dbc->original_charset), conv->server_charset.name);
+#endif
 	}
 
 	ib = src;
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 0a782af..a190a76 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -52,6 +52,7 @@
 #include <ctype.h>
 
 #include "tdsodbc.h"
+#include "tdsiconv.h"
 #include "tdsstring.h"
 #include "tdsconvert.h"
 #include "replacements.h"
@@ -60,7 +61,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.539 2010/07/03 06:57:02 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.540 2010/07/03 09:14:36 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv, SQLINTEGER odbc_version);
@@ -365,6 +366,9 @@ odbc_connect(TDS_DBC * dbc, TDSCONNECTION * connection)
 {
 	TDS_ENV *env = dbc->env;
 
+#ifdef ENABLE_ODBC_WIDE
+	dbc->mb_conv = NULL;
+#endif
 	dbc->tds_socket = tds_alloc_socket(env->tds_ctx, 512);
 	if (!dbc->tds_socket) {
 		odbc_errs_add(&dbc->errs, "HY001", NULL);
@@ -380,12 +384,21 @@ odbc_connect(TDS_DBC * dbc, TDSCONNECTION * connection)
 
 	connection->connect_timeout = dbc->attr.connection_timeout;
 
+#ifdef ENABLE_ODBC_WIDE
+	/* force utf-8 in order to support wide characters */
+	tds_dstr_dup(&dbc->original_charset, &connection->client_charset);
+	tds_dstr_copy(&connection->client_charset, "UTF-8");
+#endif
+
 	if (tds_connect_and_login(dbc->tds_socket, connection) != TDS_SUCCEED) {
 		tds_free_socket(dbc->tds_socket);
 		dbc->tds_socket = NULL;
 		odbc_errs_add(&dbc->errs, "08001", NULL);
 		ODBC_RETURN(dbc, SQL_ERROR);
 	}
+#ifdef ENABLE_ODBC_WIDE
+	dbc->mb_conv = tds_iconv_get(dbc->tds_socket, tds_dstr_cstr(&dbc->original_charset), "UTF-8");
+#endif
 
 	dbc->default_query_timeout = dbc->tds_socket->query_timeout;
 
@@ -505,8 +518,8 @@ odbc_prepare(TDS_STMT *stmt)
 #include "sqlwparams.h"
 {
 	TDSCONNECTION *connection;
-	int conlen = odbc_get_string_size(cbConnStrIn, szConnStrIn);
 	TDS_PARSED_PARAM params[ODBC_PARAM_SIZE];
+	DSTR conn_str;
 
 	INIT_HDBC;
 
@@ -533,8 +546,15 @@ odbc_prepare(TDS_STMT *stmt)
 	}
 #endif
 
+	tds_dstr_init(&conn_str);
+	if (!odbc_dstr_copy(dbc, &conn_str, cbConnStrIn, szConnStrIn _wide)) {
+		odbc_errs_add(&dbc->errs, "HY001", NULL);
+		ODBC_RETURN(dbc, SQL_ERROR);
+	}
+
 	connection = tds_alloc_connection(dbc->env->tds_ctx->locale);
 	if (!connection) {
+		tds_dstr_free(&conn_str);
 		odbc_errs_add(&dbc->errs, "HY001", NULL);
 		ODBC_RETURN(dbc, SQL_ERROR);
 	}
@@ -543,11 +563,14 @@ odbc_prepare(TDS_STMT *stmt)
 		tds_dstr_dup(&connection->database, &dbc->attr.current_catalog);
 
 	/* parse the DSN string */
-	if (!odbc_parse_connect_string(&dbc->errs, (const char *) szConnStrIn, (const char *) szConnStrIn + conlen,
-				       connection, params))
+	if (!odbc_parse_connect_string(&dbc->errs, tds_dstr_buf(&conn_str), tds_dstr_buf(&conn_str) + tds_dstr_len(&conn_str),
+				       connection, params)) {
+		tds_dstr_free(&conn_str);
 		ODBC_RETURN(dbc, SQL_ERROR);
+	}
 
-	odbc_set_string(dbc, szConnStrOut, cbConnStrOutMax, pcbConnStrOut, (const char *) szConnStrIn, conlen _wide);
+	odbc_set_string(dbc, szConnStrOut, cbConnStrOutMax, pcbConnStrOut, tds_dstr_buf(&conn_str), tds_dstr_len(&conn_str) _wide);
+	tds_dstr_free(&conn_str);
 
 	/* add login info */
 	if (hwnd && fDriverCompletion != SQL_DRIVER_NOPROMPT
@@ -1492,6 +1515,9 @@ _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc)
 	tds_dstr_init(&dbc->attr.tracefile);
 #endif
 	tds_dstr_init(&dbc->attr.translate_lib);
+#ifdef ENABLE_ODBC_WIDE
+	tds_dstr_init(&dbc->original_charset);
+#endif
 	dbc->attr.translate_option = 0;
 	dbc->attr.txn_isolation = SQL_TXN_READ_COMMITTED;
 
@@ -2178,11 +2204,27 @@ SQLColAttribute(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLUSMALLINT fDescType,
 #endif
 	)
 {
-	tdsdump_log(TDS_DBG_FUNC, "SQLColAttribute(%p, %u, %u, %p, %d, %p, %p)\n", 
-			hstmt, icol, fDescType, rgbDesc, cbDescMax, pcbDesc, pfDesc);
 
 	return _SQLColAttribute(hstmt, icol, fDescType, rgbDesc, cbDescMax, pcbDesc, pfDesc _wide0);
 }
+
+#ifdef ENABLE_ODBC_WIDE
+SQLRETURN ODBC_API
+SQLColAttributeW(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLUSMALLINT fDescType,
+		SQLPOINTER rgbDesc, SQLSMALLINT cbDescMax, SQLSMALLINT FAR * pcbDesc,
+#ifdef TDS_SQLCOLATTRIBUTE_SQLLEN
+		SQLLEN FAR * pfDesc
+#else
+		SQLPOINTER pfDesc
+#endif
+	)
+{
+	tdsdump_log(TDS_DBG_FUNC, "SQLColAttributeW(%p, %u, %u, %p, %d, %p, %p)\n",
+			hstmt, icol, fDescType, rgbDesc, cbDescMax, pcbDesc, pfDesc);
+
+	return _SQLColAttribute(hstmt, icol, fDescType, rgbDesc, cbDescMax, pcbDesc, pfDesc, 1);
+}
+#endif
 #endif
 
 SQLRETURN ODBC_API
@@ -2206,6 +2248,9 @@ SQLDisconnect(SQLHDBC hdbc)
 		}
 	}
 
+#ifdef ENABLE_ODBC_WIDE
+	dbc->mb_conv = NULL;
+#endif
 	tds_free_socket(dbc->tds_socket);
 	dbc->tds_socket = NULL;
 	dbc->cursor_support = 0;
@@ -3976,6 +4021,9 @@ _SQLFreeConnect(SQLHDBC hdbc)
 	tds_dstr_free(&dbc->attr.current_catalog);
 	tds_dstr_free(&dbc->attr.translate_lib);
 
+#ifdef ENABLE_ODBC_WIDE
+	tds_dstr_free(&dbc->original_charset);
+#endif
 	tds_dstr_free(&dbc->server);
 	tds_dstr_free(&dbc->dsn);
 
@@ -5769,6 +5817,21 @@ SQLGetInfo(SQLHDBC hdbc, SQLUSMALLINT fInfoType, SQLPOINTER rgbInfoValue, SQLSMA
 
 	ODBC_RETURN(dbc, _SQLGetInfo(dbc, fInfoType, rgbInfoValue, cbInfoValueMax, pcbInfoValue _wide0));
 }
+
+#ifdef ENABLE_ODBC_WIDE
+SQLRETURN ODBC_API
+SQLGetInfoW(SQLHDBC hdbc, SQLUSMALLINT fInfoType, SQLPOINTER rgbInfoValue, SQLSMALLINT cbInfoValueMax,
+	   SQLSMALLINT FAR * pcbInfoValue)
+{
+	INIT_HDBC;
+
+	tdsdump_log(TDS_DBG_FUNC, "SQLGetInfo(%p, %d, %p, %d, %p)\n",
+			hdbc, fInfoType, rgbInfoValue, cbInfoValueMax, pcbInfoValue);
+
+	ODBC_RETURN(dbc, _SQLGetInfo(dbc, fInfoType, rgbInfoValue, cbInfoValueMax, pcbInfoValue, 1));
+}
+#endif
+
 static void
 tds_ascii_strupr(char *s)
 {
@@ -6025,7 +6088,6 @@ SQLPutData(SQLHSTMT hstmt, SQLPOINTER rgbValue, SQLLEN cbValue)
 #include "sqlwparams.h"
 {
 	SQLULEN u_value = (SQLULEN) (TDS_INTPTR) ValuePtr;
-	int len = 0;
 
 	INIT_HDBC;
 
@@ -6049,8 +6111,19 @@ SQLPutData(SQLHSTMT hstmt, SQLPOINTER rgbValue, SQLLEN cbValue)
 			odbc_errs_add(&dbc->errs, "HY090", NULL);
 			ODBC_RETURN(dbc, SQL_ERROR);
 		}
-		len = odbc_get_string_size(StringLength, (SQLCHAR *) ValuePtr);
-		ODBC_RETURN(dbc, change_database(dbc, (char *) ValuePtr, len));
+		{
+			DSTR s;
+			SQLRETURN ret;
+
+			tds_dstr_init(&s);
+			if (!odbc_dstr_copy(dbc, &s, StringLength, ValuePtr _wide)) {
+				odbc_errs_add(&dbc->errs, "HY001", NULL);
+				ODBC_RETURN(dbc, SQL_ERROR);
+			}
+			ret = change_database(dbc, tds_dstr_cstr(&s), tds_dstr_len(&s));
+			tds_dstr_free(&s);
+			ODBC_RETURN(dbc, ret);
+		}
 		break;
 	case SQL_ATTR_CURSOR_TYPE:
 		if (dbc->cursor_support) {
@@ -6484,7 +6557,7 @@ SQLSetStmtOption(SQLHSTMT hstmt, SQLUSMALLINT fOption, SQLULEN vParam)
 	retcode =
 		odbc_stat_execute(stmt _wide, "sp_special_columns ", TDS_IS_MSSQL(stmt->dbc->tds_socket) ? 7 : 4, "O", szTableName,
 				  cbTableName, "O", szSchemaName, cbSchemaName, "O@qualifier", szCatalogName, cbCatalogName,
-				  "@col_type", &col_type, 1, "@scope", &scope, 1, "@nullable", &nullable, 1,
+				  "!@col_type", &col_type, 1, "!@scope", &scope, 1, "!@nullable", &nullable, 1,
 				  "V@ODBCVer", (char*) NULL, 0);
 	if (SQL_SUCCEEDED(retcode) && stmt->dbc->env->attr.odbc_version == SQL_OV_ODBC3) {
 		odbc_col_setname(stmt, 5, "COLUMN_SIZE");
@@ -6547,7 +6620,7 @@ SQLSetStmtOption(SQLHSTMT hstmt, SQLUSMALLINT fOption, SQLULEN vParam)
 	retcode =
 		odbc_stat_execute(stmt _wide, "sp_statistics ", TDS_IS_MSSQL(stmt->dbc->tds_socket) ? 5 : 4, "O@table_qualifier",
 				  szCatalogName, cbCatalogName, "O@table_owner", szSchemaName, cbSchemaName, "O@table_name",
-				  szTableName, cbTableName, "@is_unique", &unique, 1, "@accuracy", &accuracy, 1);
+				  szTableName, cbTableName, "!@is_unique", &unique, 1, "!@accuracy", &accuracy, 1);
 	if (SQL_SUCCEEDED(retcode) && stmt->dbc->env->attr.odbc_version == SQL_OV_ODBC3) {
 		odbc_col_setname(stmt, 1, "TABLE_CAT");
 		odbc_col_setname(stmt, 2, "TABLE_SCHEM");
@@ -6563,37 +6636,50 @@ SQLSetStmtOption(SQLHSTMT hstmt, SQLUSMALLINT fOption, SQLULEN vParam)
 #include "sqlwparams.h"
 {
 	int retcode;
-	char *type = NULL;
 	const char *proc = NULL;
 	int wildcards;
 	TDSSOCKET *tds;
+	DSTR schema_name, catalog_name, table_type;
 
 	INIT_HSTMT;
 
+	tds_dstr_init(&schema_name);
+	tds_dstr_init(&catalog_name);
+	tds_dstr_init(&table_type);
+
 	tdsdump_log(TDS_DBG_FUNC, "SQLTables(%p, %p, %d, %p, %d, %p, %d, %p, %d)\n", 
 			hstmt, szCatalogName, cbCatalogName, szSchemaName, cbSchemaName, szTableName, cbTableName, szTableType, cbTableType);
 
 	tds = stmt->dbc->tds_socket;
 
-	/* fix for processing */
-	if (cbCatalogName == SQL_NULL_DATA)
-		szCatalogName = NULL;
-	cbCatalogName = odbc_get_string_size(cbCatalogName, szCatalogName);
+	if (!odbc_dstr_copy(stmt->dbc, &catalog_name, cbCatalogName, szCatalogName _wide)
+	    || !odbc_dstr_copy(stmt->dbc, &schema_name, cbSchemaName, szSchemaName _wide)
+	    || !odbc_dstr_copy(stmt->dbc, &table_type, cbTableType, szTableType _wide)) {
+		tds_dstr_free(&schema_name);
+		tds_dstr_free(&catalog_name);
+		tds_dstr_free(&table_type);
+		odbc_errs_add(&stmt->errs, "HY001", NULL);
+		ODBC_RETURN(stmt, SQL_ERROR);
+	}
+
+	cbCatalogName = tds_dstr_len(&catalog_name);
+	cbSchemaName = tds_dstr_len(&schema_name);
+	cbTableType = tds_dstr_len(&table_type);
 
 	/* support wildcards on catalog (only odbc 3) */
 	wildcards = 0;
 	if (stmt->dbc->env->attr.odbc_version == SQL_OV_ODBC3 && stmt->dbc->attr.metadata_id == SQL_FALSE &&
-	    (memchr(szCatalogName, '%', cbCatalogName) || memchr(szCatalogName, '_', cbCatalogName)))
+	    (strchr(tds_dstr_cstr(&catalog_name), '%') || strchr(tds_dstr_cstr(&catalog_name), '_')))
 		wildcards = 1;
 
 	proc = "sp_tables ";
-	if (cbCatalogName > 0 && (cbCatalogName != 1 || szCatalogName[0] != '%' || cbTableName > 0 || cbSchemaName > 0)) {
+	if (cbCatalogName > 0) {
 		if (wildcards) {
 			/* if catalog specified and wildcards use sp_tableswc under mssql2k */
 			if (TDS_IS_MSSQL(tds) && tds->product_version >= TDS_MS_VER(8,0,0)) {
 				proc = "sp_tableswc ";
 				if (cbSchemaName == SQL_NULL_DATA) {
-					szSchemaName = (SQLCHAR *) "%";
+					tds_dstr_copy(&schema_name, "%");
 					cbSchemaName = 1;
 				}
 			}
@@ -6611,15 +6697,14 @@ SQLSetStmtOption(SQLHSTMT hstmt, SQLUSMALLINT fOption, SQLULEN vParam)
 	}
 
 	/* fix type if needed quoting it */
-	if (szTableType && cbTableType != SQL_NULL_DATA) {
-		int len = odbc_get_string_size(cbTableType, szTableType);
+	if (cbTableType > 0) {
 		int to_fix = 0;
 		int elements = 0;
-		char *p = (char *) szTableType;
-		char *const end = p + len;
+		const char *p = tds_dstr_cstr(&table_type);
+		const char *const end = p + tds_dstr_len(&table_type);
 
 		for (;;) {
-			char *begin = p;
+			const char *begin = p;
 
 			p = memchr(p, ',', end - p);
 			if (!p)
@@ -6632,20 +6717,20 @@ SQLSetStmtOption(SQLHSTMT hstmt, SQLUSMALLINT fOption, SQLULEN vParam)
 			++p;
 		}
 		/* fix it */
-		tdsdump_log(TDS_DBG_INFO1, "len %d to_fix %d elements %d\n", len, to_fix, elements);
-		if (len && to_fix) {
-			char *dst;
+		tdsdump_log(TDS_DBG_INFO1, "to_fix %d elements %d\n", to_fix, elements);
+		if (to_fix) {
+			char *dst, *type;
 
 			tdsdump_log(TDS_DBG_INFO1, "fixing type elements\n");
-			type = (char *) malloc(len + elements * 2);
+			type = (char *) malloc(tds_dstr_len(&table_type) + elements * 2 + 3);
 			if (!type) {
 				odbc_errs_add(&stmt->errs, "HY001", NULL);
 				ODBC_RETURN(stmt, SQL_ERROR);
 			}
-			p = (char *) szTableType;
+			p = tds_dstr_cstr(&table_type);
 			dst = type;
 			for (;;) {
-				char *begin = p;
+				const char *begin = p;
 
 				p = memchr(p, ',', end - p);
 				if (!p)
@@ -6663,16 +6748,19 @@ SQLSetStmtOption(SQLHSTMT hstmt, SQLUSMALLINT fOption, SQLULEN vParam)
 					break;
 				*dst++ = *p++;
 			}
-			cbTableType = dst - type;
-			szTableType = (SQLCHAR *) type;
+			*dst = 0;
+			tds_dstr_set(&table_type, type);
+			cbTableType = tds_dstr_len(&table_type);
 		}
 	}
 
 	retcode =
-		odbc_stat_execute(stmt, proc, 4, "P@table_name", szTableName, cbTableName, "P@table_owner", szSchemaName,
-				  cbSchemaName, "P@table_qualifier", szCatalogName, cbCatalogName, "@table_type", szTableType,
-				  cbTableType);
-	free(type);
+		odbc_stat_execute(stmt _wide, proc, 4, "P@table_name", szTableName, cbTableName, "!P@table_owner", tds_dstr_cstr(&schema_name),
+				  cbSchemaName, "!P@table_qualifier", tds_dstr_cstr(&catalog_name), cbCatalogName,
+				  "!@table_type", tds_dstr_cstr(&table_type), cbTableType);
+	tds_dstr_free(&schema_name);
+	tds_dstr_free(&catalog_name);
+	tds_dstr_free(&table_type);
 	if (SQL_SUCCEEDED(retcode) && stmt->dbc->env->attr.odbc_version == SQL_OV_ODBC3) {
 		odbc_col_setname(stmt, 1, "TABLE_CAT");
 		odbc_col_setname(stmt, 2, "TABLE_SCHEM");
@@ -6767,10 +6855,12 @@ odbc_log_unimplemented_type(const char function_name[], int fType)
 }
 
 static int
-odbc_quote_metadata(TDS_DBC * dbc, char type, char *dest, const char *s, int len)
+odbc_quote_metadata(TDS_DBC * dbc, char type, char *dest, DSTR * dstr)
 {
 	int unquote = 0;
 	char prev, buf[1200], *dst;
+	const char *s = tds_dstr_cstr(dstr);
+	int len = tds_dstr_len(dstr);
 
 	if (!type || (type == 'O' && dbc->attr.metadata_id == SQL_FALSE))
 		return tds_quote_string(dbc->tds_socket, dest, s, len);
@@ -6858,9 +6948,8 @@ odbc_stat_execute(TDS_STMT * stmt _WIDE, const char *begin, int nparams, ...)
 {
 	struct param
 	{
+		DSTR value;
 		char *name;
-		char *value;
-		int len;
 		char type;
 	}
 	params[ODBC_MAX_STAT_PARAM];
@@ -6876,10 +6965,16 @@ odbc_stat_execute(TDS_STMT * stmt _WIDE, const char *begin, int nparams, ...)
 	va_start(marker, nparams);
 	len = strlen(begin) + 2;
 	for (i = 0; i < nparams; ++i) {
-		int param_len;
+		int param_len, convert = 1;
+		DSTR *out;
 
 		p = va_arg(marker, char *);
 
+		if (*p == '!') {
+			convert = 0;
+			++p;
+		}
+
 		switch (*p) {
 		case 'V':	/* ODBC version */
 			len += strlen(p) + 3;
@@ -6893,18 +6988,31 @@ odbc_stat_execute(TDS_STMT * stmt _WIDE, const char *begin, int nparams, ...)
 		}
 		params[i].name = p;
 
-		params[i].value = va_arg(marker, char *);
+		p = va_arg(marker, char *);
 		param_len = va_arg(marker, int);
-		if (params[i].value && param_len != SQL_NULL_DATA) {
-			params[i].len = odbc_get_string_size(param_len, (SQLCHAR *) params[i].value);
+		tds_dstr_init(&params[i].value);
+#ifdef ENABLE_ODBC_WIDE
+		if (!convert)
+			out = tds_dstr_copyn(&params[i].value, p, param_len);
+		else
+			out = odbc_dstr_copy(stmt->dbc, &params[i].value, param_len, (ODBC_CHAR *) p _wide);
+#else
+		out = odbc_dstr_copy(stmt->dbc, &params[i].value, param_len, (ODBC_CHAR *) p _wide);
+#endif
+		if (!out) {
+			while (--i >= 0)
+				tds_dstr_free(&params[i].value);
+			odbc_errs_add(&stmt->errs, "HY001", NULL);
+			ODBC_RETURN(stmt, SQL_ERROR);
+		}
+		if (!tds_dstr_isempty(&params[i].value)) {
 			len += strlen(params[i].name) + odbc_quote_metadata(stmt->dbc, params[i].type, NULL, 
-									    params[i].value, params[i].len) + 3;
+									    &params[i].value) + 3;
 			if (begin[0] == '.' && strstr(params[i].name, "qualifier")) {
-				len += tds_quote_id(stmt->dbc->tds_socket, NULL, params[i].value, params[i].len);
+				len += tds_quote_id(stmt->dbc->tds_socket, NULL,
+						    tds_dstr_cstr(&params[param_qualifier].value), tds_dstr_len(&params[param_qualifier].value));
 				param_qualifier = i;
 			}
-		} else {
-			params[i].value = NULL;
 		}
 
 	}
@@ -6912,6 +7020,8 @@ odbc_stat_execute(TDS_STMT * stmt _WIDE, const char *begin, int nparams, ...)
 
 	/* allocate space for string */
 	if (!(proc = (char *) malloc(len))) {
+		for (i = 0; i < nparams; ++i)
+			tds_dstr_free(&params[i].value);
 		odbc_errs_add(&stmt->errs, "HY001", NULL);
 		ODBC_RETURN(stmt, SQL_ERROR);
 	}
@@ -6919,11 +7029,11 @@ odbc_stat_execute(TDS_STMT * stmt _WIDE, const char *begin, int nparams, ...)
 	/* build string */
 	p = proc;
 	if (param_qualifier >= 0)
-		p += tds_quote_id(stmt->dbc->tds_socket, p, params[param_qualifier].value, params[param_qualifier].len);
+		p += tds_quote_id(stmt->dbc->tds_socket, p, tds_dstr_cstr(&params[param_qualifier].value), tds_dstr_len(&params[param_qualifier].value));
 	strcpy(p, begin);
 	p += strlen(begin);
 	for (i = 0; i < nparams; ++i) {
-		if (!params[i].value && params[i].type != 'V')
+		if (tds_dstr_isempty(&params[i].value) && params[i].type != 'V')
 			continue;
 		if (params[i].name[0]) {
 			strcpy(p, params[i].name);
@@ -6931,15 +7041,17 @@ odbc_stat_execute(TDS_STMT * stmt _WIDE, const char *begin, int nparams, ...)
 			*p++ = '=';
 		}
 		if (params[i].type != 'V')
-			p += odbc_quote_metadata(stmt->dbc, params[i].type, p, params[i].value, params[i].len);
+			p += odbc_quote_metadata(stmt->dbc, params[i].type, p, &params[i].value);
 		else
 			*p++ = (stmt->dbc->env->attr.odbc_version == SQL_OV_ODBC3) ? '3': '2';
 		*p++ = ',';
+		tds_dstr_free(&params[i].value);
 	}
 	*--p = '\0';
 	assert(p - proc + 1 <= len);
 
 	/* set it */
+	/* FIXME is neither mb or wide, is always utf encoded !!! */
 	retcode = odbc_set_stmt_query(stmt, (ODBC_CHAR *) proc, p - proc _wide0);
 	free(proc);
 
